VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AddAggregate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'******************************************************************************
'   Application: SUSTAIN - Best Management Practice Decision Support System
'   Company:     Tetra Tech, Inc
'   Designer:    Leslie Shoemaker, Ting Dai, Khalid Alvi, Jenny Zhen, John Riverson, Sabu Paul
'   Developer:   Haihong Yang, Sabu Paul, Mira Chokshi
'   History:     Created:
'                Modified: 03/29/2005 - mira chokshi added comments to project
'
'******************************************************************************


Option Explicit
Implements ICommand
Implements ITool
Private m_Bitmap As IPictureDisp

Private Sub Class_Initialize()
    'Set m_Bitmap = LoadResPicture("Junction", 0) '"AggLuDistribution"
    Set m_Bitmap = LoadResPicture("AggregateBMP", 0)
End Sub

Private Sub Class_Terminate()
    Set m_Bitmap = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
    ICommand_Bitmap = m_Bitmap
End Property

Private Property Get ICommand_Caption() As String
    ICommand_Caption = "Add Aggregate"
End Property

Private Property Get ICommand_Category() As String
    ICommand_Category = "SUSTAIN"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
       ICommand_Enabled = ModuleMenu.EnableIndividualBMPTool("Aggregate")
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
    ICommand_Message = "Add Aggregate"
End Property

Private Property Get ICommand_Name() As String
    ICommand_Name = "AddAggregate"
End Property

Private Sub ICommand_OnClick()
    Call InitializeMapDocument
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
    Set gApplication = hook
End Sub

Private Property Get ICommand_Tooltip() As String
    ICommand_Tooltip = "Add Aggregate"
End Property

Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE
    ITool_Cursor = LoadResPicture("bmpAgg", vbResCursor)
End Property

Private Function ITool_Deactivate() As Boolean
    ITool_Deactivate = True
End Function

Private Function ITool_OnContextMenu(ByVal X As Long, ByVal Y As Long) As Boolean
  
End Function

Private Sub ITool_OnDblClick()

End Sub

Private Sub ITool_OnKeyDown(ByVal KeyCode As Long, ByVal Shift As Long)
     
End Sub

Private Sub ITool_OnKeyUp(ByVal KeyCode As Long, ByVal Shift As Long)
     
End Sub

Private Sub ITool_OnMouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
    On Error GoTo ErrorHandler
    If gInternalSimulation Then
        MsgBox "Adding an Aggregate BMP is not for the internal option!", vbInformation
        GoTo CleanUp
    End If
    
    Dim pWatershedFLayer As IFeatureLayer
    Set pWatershedFLayer = GetInputFeatureLayer("Watershed")
    If Not (pWatershedFLayer Is Nothing) Then
        
    
    
        '** define the feature class and ID field index
        Dim pWatershedFClass As IFeatureClass
        Set pWatershedFClass = pWatershedFLayer.FeatureClass
        Dim iID As Long
        iID = pWatershedFClass.FindField("ID")
            
        '** get the point on map and transform it
        Dim pDisp As IScreenDisplay
        Set pDisp = gMxDoc.ActiveView.ScreenDisplay
        Dim pDispTrans As IDisplayTransformation
        Set pDispTrans = pDisp.DisplayTransformation
        Dim pMapPoint As IPoint
        Set pMapPoint = pDispTrans.ToMapPoint(X, Y)
        
        '** expand the point
        Dim pEnvelope As IEnvelope
        Set pEnvelope = pMapPoint.Envelope
        Set pEnvelope = ExpandPointEnvelope(pEnvelope)
    
        '** define a spatial filter
        Dim pSpatialFilter As ISpatialFilter
        Set pSpatialFilter = New SpatialFilter
        Set pSpatialFilter.Geometry = pEnvelope
        pSpatialFilter.SpatialRel = esriSpatialRelIntersects
        
        '** define the feature cursor and feature for it
        Dim pFeatureCursor As IFeatureCursor
        Dim pFeature As IFeature
        Set pFeatureCursor = pWatershedFClass.Search(pSpatialFilter, True)
        Set pFeature = pFeatureCursor.NextFeature
    
        
        'Determine if the watershed has already a Disconnected BMP
        Dim bReplace As Variant
        bContinue = vbNo
        If Not (pFeature Is Nothing) Then
        
            Dim pPolygon As IPolygon
            Set pPolygon = pFeature.Shape
            Dim lNumofAggregate As Long
            lNumofAggregate = NumOfBMPInCurrentWater(pPolygon, "Aggregate")

            If lNumofAggregate >= 1 Then
                bReplace = MsgBox("Only one Aggregate BMP is allowed in a subwatershed", vbExclamation, "Add BMP")
                GoTo CleanUp
            End If
        End If
    End If
    
    AddBMPFromToolbox Button, Shift, X, Y, "Aggregate"
    GoTo CleanUp

ErrorHandler:
    MsgBox "Error in ITool_OnMouseDown AddAggregate module, ITool_OnMouseDown: " & Err.description

CleanUp:
End Sub

Private Sub ITool_OnMouseMove(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
    
End Sub

Private Sub ITool_OnMouseUp(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
    
End Sub

Private Sub ITool_Refresh(ByVal hdc As esriSystem.OLE_HANDLE)

End Sub





