VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AddImpDisconnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'******************************************************************************
'   Application: SUSTAIN - Best Management Practice Decision Support System
'   Company:     Tetra Tech, Inc
'   Designer:    Leslie Shoemaker, Ting Dai, Khalid Alvi, Jenny Zhen, John Riverson, Sabu Paul
'   Developer:   Haihong Yang, Sabu Paul, Mira Chokshi
'   History:     Created: 06/20/2005 - Mira Chokshi create this module.
'
'******************************************************************************

Option Explicit

Implements ICommand
Implements ITool
Private m_Bitmap As IPictureDisp

'added for the new functions for Impervious Disconnection Oct 2011
Private m_pEditor As IEditor
Private m_pEditSketch As IEditSketch

Private m_bInUse As Boolean
Private m_pPoint As IPoint
Private m_pFeedback As IDisplayFeedback


Private Sub Class_Initialize()
    Set m_Bitmap = LoadResPicture("ImpDisconnection", vbResBitmap)
End Sub

Private Sub Class_Terminate()
    Set m_Bitmap = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
    ICommand_Bitmap = m_Bitmap
End Property

Private Property Get ICommand_Caption() As String
    ICommand_Caption = "Add Impervious Disconnection"
End Property

Private Property Get ICommand_Category() As String
    ICommand_Category = "SUSTAIN"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
    'ICommand_Enabled = ModuleMenu.EnableAddVFS
    ICommand_Enabled = ModuleMenu.EnableIndividualBMPTool("DisconnectedImp")
    
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
    ICommand_Message = "Add Impervious Disconnection"
End Property

Private Property Get ICommand_Name() As String
    ICommand_Name = "Add Impervious Disconnection"
End Property

Private Sub ICommand_OnClick()

    Call InitializeMapDocument
    
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
    Set gApplication = hook
End Sub

Private Property Get ICommand_Tooltip() As String
    ICommand_Tooltip = "Add Impervious Disconnection"
End Property

Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE
    ITool_Cursor = LoadResPicture("DIGITIZE", vbResCursor)
End Property

Private Function ITool_Deactivate() As Boolean
    ITool_Deactivate = True
End Function

Private Function ITool_OnContextMenu(ByVal X As Long, ByVal Y As Long) As Boolean
  
End Function

Private Sub ITool_OnDblClick()
End Sub

Private Sub ITool_OnKeyDown(ByVal KeyCode As Long, ByVal Shift As Long)
     
End Sub

Private Sub ITool_OnKeyUp(ByVal KeyCode As Long, ByVal Shift As Long)
     
End Sub



Private Sub ITool_OnMouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
On Error GoTo ErrorHandler
    If gInternalSimulation Then
        MsgBox "Adding an Impervious Disconnection BMP is not for the internal option!", vbInformation
        Exit Sub
    End If

    '** get the watershed on which the mouse is clicked
    Dim pWatershedFLayer As IFeatureLayer
    Set pWatershedFLayer = GetInputFeatureLayer("Watershed")
    If (pWatershedFLayer Is Nothing) Then
        MsgBox "Watershed feature layer not found."
        Exit Sub
    End If
    
    gBMPTypeToolbox = "DisconnectedImp"
    
    '** define the feature class and ID field index
    Dim pWatershedFClass As IFeatureClass
    Set pWatershedFClass = pWatershedFLayer.FeatureClass
    Dim iID As Long
    iID = pWatershedFClass.FindField("ID")
        
    '** get the point on map and transform it
    Dim pDisp As IScreenDisplay
    Set pDisp = gMxDoc.ActiveView.ScreenDisplay
    Dim pDispTrans As IDisplayTransformation
    Set pDispTrans = pDisp.DisplayTransformation
    Dim pMapPoint As IPoint
    Set pMapPoint = pDispTrans.ToMapPoint(X, Y)
    
    '** expand the point
    Dim pEnvelope As IEnvelope
    Set pEnvelope = pMapPoint.Envelope
    Set pEnvelope = ExpandPointEnvelope(pEnvelope)

    '** define a spatial filter
    Dim pSpatialFilter As ISpatialFilter
    Set pSpatialFilter = New SpatialFilter
    Set pSpatialFilter.Geometry = pEnvelope
    pSpatialFilter.SpatialRel = esriSpatialRelIntersects
    
    '** define the feature cursor and feature for it
    Dim pFeatureCursor As IFeatureCursor
    Dim pFeature As IFeature
    Set pFeatureCursor = pWatershedFClass.Search(pSpatialFilter, True)
    Set pFeature = pFeatureCursor.NextFeature

    Dim pX As Double
    Dim pY As Double
    If Not (pFeature Is Nothing) Then
        gSubCatchmentID = pFeature.value(iID)
        pX = pMapPoint.X
        pY = pMapPoint.Y
        '** flash the polygon to confirm
        FlashWatershedFeature pFeature
        
    End If
    
    'Determine if the watershed has already a Disconnected BMP
    Dim strSubwaterPropName As String
    strSubwaterPropName = "SubWaterID"
    Dim bReplace As Variant
    bContinue = vbNo
    If Not (pFeature Is Nothing) Then

        If DisconIMPExistInCurrentWater(gSubCatchmentID, strSubwaterPropName) Then
            bReplace = MsgBox("There is already a Disconnected Imperviousness in the current watershed. A new Disconnected Imperviousness cannot placed here until the original one is deleted!", vbExclamation, "Add BMP")
        Else
    
            bContinue = MsgBox("Do you want to add a BMP at this point ?" & _
                                " Click Yes to continue and No to cancel. ", vbYesNo, "Add BMP")
            If (bContinue = vbYes) Then
                gBMPTypeToolbox = "DisconnectedImp"
                
                'FrmSelectBMPImpDisconn.Form_Initialize
                'FrmSelectBMPImpDisconn.txtImpArea.Text = CStr(Format(ComputeImpAreaEachWater(gSubCatchmentID), "#.00"))
                'FrmSelectBMPImpDisconn.txtPerArea.Text = CStr(Format(ComputePerAreaEachWater(gSubCatchmentID), "#.00"))
                'FrmSelectBMPImpDisconn.Show vbModal
                FrmSelectBMP.Form_Initialize
                FrmSelectBMP.Show vbModal
                bRegulator = False
                
                gBMPDetailDict.add strSubwaterPropName, gSubCatchmentID
                gBMPDetailDict.add "txtImpArea", CStr(Format(ComputeImpAreaEachWater(gSubCatchmentID), "#.00"))
                gBMPDetailDict.add "txtPerArea", CStr(Format(ComputePerAreaEachWater(gSubCatchmentID), "#.00"))

                If (bContinue = vbYes) Then
                    AddBMPOnLand Button, Shift, X, Y, "DisconnectedImp"
                End If

            End If
        End If
    Else
    
        MsgBox "please click on the subwatershed!"
    End If
    
    

    

  
  GoTo CleanUp

ErrorHandler:
    MsgBox "Error in ITool_OnMouseDown AddImpDisconnection module, ITool_OnMouseDown: " & Err.description
    Resume
    
CleanUp:
  

End Sub

Private Sub ITool_OnMouseMove(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)

End Sub

Private Sub ITool_OnMouseUp(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
    
End Sub

Private Sub ITool_Refresh(ByVal hdc As esriSystem.OLE_HANDLE)

End Sub

