VERSION 5.00
Begin VB.Form FrmImptTS 
   Caption         =   "Import Time Series Table"
   ClientHeight    =   1590
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5385
   DrawWidth       =   10
   LinkTopic       =   "Form1"
   ScaleHeight     =   1590
   ScaleWidth      =   5385
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox TableLst 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   4095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3000
      TabIndex        =   2
      Top             =   960
      Width           =   855
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4200
      TabIndex        =   1
      Top             =   960
      Width           =   855
   End
   Begin VB.CommandButton findTable 
      Caption         =   "Browse"
      Height          =   340
      Left            =   4320
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   480
      Width           =   720
   End
   Begin VB.Label Label1 
      Caption         =   "Import Time Series Default Table"
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   240
      Width           =   2775
   End
End
Attribute VB_Name = "FrmImptTS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
On Error GoTo ErrorHandler
    'On Select close the dialog box
    If (TableLst.Text <> "") Then
        If TableLst.Text = "TSAssigns" Then
            MsgBox "The land use default lookup table could not be of name: TSAssigns", vbExclamation
            Exit Sub
        End If
        
        Dim pLUReClasstable As iTable
        Set pLUReClasstable = GetInputDataTable(TableLst.Text)

        Dim pLUGroupIDindex As Long
        pLUGroupIDindex = pLUReClasstable.FindField("LUGroupID")
        If pLUGroupIDindex <= -1 Then
            MsgBox "Field LUGroupID does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pLUGroupindex As Long
        pLUGroupindex = pLUReClasstable.FindField("LUGroup")
        If pLUGroupindex <= -1 Then
            MsgBox "Field LUGroup does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pLUCodeindex As Long
        pLUCodeindex = pLUReClasstable.FindField("LUCode")
        If pLUCodeindex <= -1 Then
            MsgBox "Field LUCode does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If

        Dim pLUDescIndex As Long
        pLUDescIndex = pLUReClasstable.FindField("LUDescrip")
        If pLUDescIndex <= -1 Then
            MsgBox "Field LUDescrip does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pPercentageIndex As Long
        pPercentageIndex = pLUReClasstable.FindField("Percentage")
        If pPercentageIndex <= -1 Then
            MsgBox "Field Percentage does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pLUTypeindex As Long
        pLUTypeindex = pLUReClasstable.FindField("Impervious")
        If pLUTypeindex <= -1 Then
            MsgBox "Field Impervious does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pTimeSeriesindex As Long
        pTimeSeriesindex = pLUReClasstable.FindField("TimeSeries")
        If pTimeSeriesindex <= -1 Then
            MsgBox "Field TimeSeries does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        'Sand, Silt and Clay fraction
        Dim pSandFracindex As Long
        pSandFracindex = pLUReClasstable.FindField("SandFrac")
        If pSandFracindex <= -1 Then
            MsgBox "Field SandFrac does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pSiltFracindex As Long
        pSiltFracindex = pLUReClasstable.FindField("SiltFrac")
        If pSiltFracindex <= -1 Then
            MsgBox "Field SiltFrac does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        Dim pClayFracindex As Long
        pClayFracindex = pLUReClasstable.FindField("ClayFrac")
        If pClayFracindex <= -1 Then
            MsgBox "Field ClayFrac does not exist in table " & TableLst.Text & ". Please check!", vbExclamation
            Exit Sub
        End If
        
        If Not CheckLucode(TableLst.Text) Then
            MsgBox "The land use code should be of one to one mapping with the land use raster data. Please check!", vbExclamation
            Exit Sub
        End If
        Dim strLUGroupID As String
        If Not CheckLUGroupSpace(TableLst.Text, strLUGroupID) Then
            MsgBox "The land use group could neither contain space nor be blank in Land use groupID " & strLUGroupID & ". Please check!", vbExclamation
            Exit Sub
        End If
        
        Dim strTSfile As String
        If Not CheckTSExistance(TableLst.Text, strTSfile) Then
            MsgBox "The time series file: " & strTSfile & " could not be found. Please check!", vbExclamation
            Exit Sub
        End If
        
        Dim strLUCnotSum1 As String
        If Not CheckTSLUCsum1(TableLst.Text, strLUCnotSum1) Then
            MsgBox "The sum of percentage for land use code: " & strLUCnotSum1 & " does not equal to one. Please check!", vbExclamation
            Exit Sub
        End If
        
        'Add watershed layer in input file
        gLayerNameDictionary.Item("DefaultTS") = TableLst.Text
        'Call the subroutine to write this layer into src file
        Call WriteLayerTagDictionaryToSRCFile
        'First remove all the entries from listTimeSeries
        Dim pIndex As Integer
        For pIndex = FrmTSAssign.ListTimeSeries.ListItems.Count To 1 Step -1
            FrmTSAssign.ListTimeSeries.ListItems.Remove (pIndex)
        Next pIndex
        'Read the lulookup table and enter the default info in ListTimeSeries
        
        Dim pLuLuTable As iTable
        'Set pLuLuTable = GetInputDataTable("LuLookup")
        'Set pLuLuTable = GetInputDataTable(cmbLanduseTable.Text)
        Set pLuLuTable = GetInputDataTable(FrmImptTS.TableLst.Text)
        If (pLuLuTable Is Nothing) Then
            MsgBox "Landuse lookup table is missing: Run layer validation"
            Exit Sub
        End If

        'pLUGroupindex = pLuLuTable.FindField("LUGroupID")
        pLUCodeindex = pLuLuTable.FindField("LUCode")
        
        'pLUDescIndex = pLuLuTable.FindField("LUDesc")
        pLUDescIndex = pLuLuTable.FindField("LUDescrip")
        'pPercentageIndex = pLuLuTable.FindField("PercImp")
        pPercentageIndex = pLuLuTable.FindField("Percentage")
        'Dim pPerTSFindex As Long
        'pPerTSFindex = pLuLuTable.FindField("Perts")
        pIsImpervIndex = pLuLuTable.FindField("Impervious")
        TSFindex = pLuLuTable.FindField("TimeSeries")
        SandIndex = pLuLuTable.FindField("SandFrac")
        SiltIndex = pLuLuTable.FindField("SiltFrac")
        ClayIndex = pLuLuTable.FindField("ClayFrac")
    
        Dim pLucode As Integer
        Dim pLUType As String
        Dim pLUDescription As String
        Dim pLuPercent As Double
        Dim pLuGroupID As Integer
        Dim pLuGroup As String
        Dim pTimeSeries As String
        Dim strTimeSeries As String
        Dim pCursor As ICursor
        Set pCursor = pLuLuTable.Search(Nothing, True)
        
        Dim pRow As iRow
        Set pRow = pCursor.NextRow
        
        Dim pRowCount As Integer
        pRowCount = 1
        
        
        Dim defGroupDict As Scripting.Dictionary
        Set defGroupDict = CreateObject("Scripting.Dictionary")
        
        Dim fso As Scripting.FileSystemObject
        Set fso = CreateObject("Scripting.FileSystemObject")
        
    
        Do While Not pRow Is Nothing
            pLucode = pRow.value(pLUCodeindex)
            pLUDescription = pRow.value(pLUDescIndex)
            pLuPercent = pRow.value(pPercentageIndex)
            pLuGroup = pRow.value(pLUGroupindex)
            If (defGroupDict.Exists(pLuGroup)) Then
                pLuGroupID = defGroupDict.Item(pLuGroup)
            Else
                pLuGroupID = defGroupDict.Count
                defGroupDict.Item(pLuGroup) = pLuGroupID
            End If
            
            strTimeSeries = pRow.value(TSFindex)
            
            Dim itmX
                        
            'insert the pervious land time series
            If Not fso.FileExists(strTimeSeries) Then
                
                MsgBox "The time series file " & strTimeSeries & " could not be found!", vbExclamation
                Exit Sub
            End If
            Set itmX = FrmTSAssign.ListTimeSeries.ListItems.add(, , pLuGroupID) 'Code
            itmX.SubItems(1) = pLuGroup ' Description
            itmX.SubItems(2) = pLucode
            itmX.SubItems(3) = pLUDescription
            'pLUType = 0
            pLUType = CLng(pRow.value(pIsImpervIndex))
            itmX.SubItems(4) = pLUType
            itmX.SubItems(5) = Format(pLuPercent * 100, "#.000")

            itmX.SubItems(6) = strTimeSeries
            itmX.SubItems(7) = Format(CDbl(pRow.value(SandIndex)), "0.000")
            itmX.SubItems(8) = Format(CDbl(pRow.value(SiltIndex)), "0.000")
            itmX.SubItems(9) = Format(CDbl(pRow.value(ClayIndex)), "0.000")
             
            pRowCount = pRowCount + 1
            
            Set pRow = pCursor.NextRow
        Loop
        pGroupIndex = defGroupDict.Count + 1
        'Remove all the row ListLUType
        For pIndex = FrmTSAssign.listLUType.ListItems.Count To 1 Step -1
            FrmTSAssign.listLUType.ListItems.Remove (pIndex)
        Next pIndex
        
    End If
    Unload Me
    Exit Sub
ErrorHandler:
  HandleError True, "FrmImptTS_cmdOK " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.description

    
End Sub


Private Sub findTable_Click()
    Dim strTable As String
    strTable = SelectLayerOrTableData("GeoTable")
    If (Trim(strTable) <> "") Then
        TableLst.AddItem strTable
        TableLst.ListIndex = TableLst.ListCount - 1
    End If

End Sub

Private Sub Form_Load()
    Set Me.Icon = LoadResPicture("SUSTAIN", vbResIcon)


    Dim pTabCollection As IStandaloneTableCollection
    Set pTabCollection = gMap
    ReDim TableNames(pTabCollection.StandaloneTableCount)
    For i = 0 To (pTabCollection.StandaloneTableCount - 1)
        TableLst.AddItem pTabCollection.StandaloneTable(i).name
    Next


    For i = 0 To TableLst.ListCount - 1
        If gLayerNameDictionary.Item("DefaultTS") = Trim(TableLst.List(i)) Then
            TableLst.ListIndex = i
            Exit For
        End If
    Next

End Sub

