VERSION 5.00
Begin VB.Form FrmOptimizeCost 
   Caption         =   "Minimize Cost"
   ClientHeight    =   4905
   ClientLeft      =   4875
   ClientTop       =   4185
   ClientWidth     =   7485
   ControlBox      =   0   'False
   DrawWidth       =   10
   Icon            =   "FrmOptimizeCost.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4905
   ScaleWidth      =   7485
   Begin VB.Frame Frame3 
      Caption         =   "Set Search Stopping Criteria"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Index           =   1
      Left            =   120
      TabIndex        =   10
      Top             =   2640
      Width           =   5655
      Begin VB.TextBox MaxRunTime 
         Height          =   375
         Left            =   4080
         TabIndex        =   11
         Top             =   240
         Width           =   975
      End
      Begin VB.Label Label9 
         Caption         =   "Maximum number of iterations"
         Height          =   375
         Left            =   240
         TabIndex        =   12
         Top             =   240
         Width           =   3135
      End
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4800
      TabIndex        =   9
      Top             =   4080
      Width           =   975
   End
   Begin VB.Frame Frame2 
      Caption         =   "Number of Near Optimal Solutions"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   5655
      Begin VB.TextBox NumBest 
         Height          =   375
         Left            =   4080
         TabIndex        =   1
         Top             =   480
         Width           =   975
      End
      Begin VB.Label Label5 
         Caption         =   "Number of near optimal solutions for output"
         Height          =   375
         Left            =   240
         TabIndex        =   8
         Top             =   480
         Width           =   3855
      End
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3480
      TabIndex        =   6
      Top             =   4080
      Width           =   975
   End
   Begin VB.Frame Frame1 
      Caption         =   "Set Search Stopping Criteria"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   1200
      Width           =   5655
      Begin VB.TextBox StopDelta 
         Height          =   375
         Left            =   4080
         TabIndex        =   2
         Top             =   360
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "$"
         Height          =   255
         Left            =   5160
         TabIndex        =   5
         Top             =   400
         Width           =   255
      End
      Begin VB.Label Label1 
         Caption         =   "Stop the search and output near optimal solutions when the total cost has NOT been reduced by"
         Height          =   495
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   3735
      End
      Begin VB.Label Label4 
         Height          =   255
         Left            =   5160
         TabIndex        =   3
         Top             =   1300
         Width           =   375
      End
   End
End
Attribute VB_Name = "FrmOptimizeCost"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    
    Dim pStopDelta As Double
    Dim pMaxRunTime As Double
    Dim pNumBest As Integer
    
    '*** Cost Limit i.e. Stop Delta
    If Not (IsNumeric(StopDelta)) Then
        MsgBox "Cost should be a numeric value."
        StopDelta.SetFocus
        Exit Sub
    End If
    If (CDbl(StopDelta) < 0) Then
        MsgBox "Cost should be a positive numeric value."
        StopDelta.SetFocus
        Exit Sub
    End If
    pStopDelta = CDbl(StopDelta)
    
    '*** Max. run time
    If Not (IsNumeric(MaxRunTime)) Then
        MsgBox "Search time allowed should be a numeric value."
        MaxRunTime.SetFocus
        Exit Sub
    End If
    If (CDbl(MaxRunTime) < 0) Then
        MsgBox "Search time allowed should be a positive numeric value."
        MaxRunTime.SetFocus
        Exit Sub
    End If
    pMaxRunTime = CDbl(MaxRunTime)
    'pMaxRunTime = -99
    '*** Number of Best Solutions
    If Not (IsNumeric(NumBest)) Then
        MsgBox "Number of near optimal solutions should be a numeric value."
        NumBest.SetFocus
        Exit Sub
    End If
    If (CInt(NumBest) < 0) Then
        MsgBox "Number of near optimal solutions should be a positive numeric value."
        NumBest.SetFocus
        Exit Sub
    End If
    pNumBest = CInt(NumBest)
    
    'Close form
    Unload Me
    
    'Call the subroutine to update this option
    DefineOptimizationMethod 1, 0, pStopDelta, pMaxRunTime, pNumBest
                        
        
End Sub

Private Sub Form_Load()
    Set Me.Icon = LoadResPicture("SUSTAIN", vbResIcon)
    Dim pOptimizationTable As iTable
    Set pOptimizationTable = GetInputDataTable("OptimizationDetail")
    If (pOptimizationTable Is Nothing) Then Exit Sub

    'Query in the table for existing records
    Dim pQueryFilter As IQueryFilter
    Set pQueryFilter = New QueryFilter
       
    lineNum = 3
    Dim pCursor As ICursor
    Dim pRow As iRow
    Dim iPropValue As Long
    iPropValue = pOptimizationTable.FindField("PropValue")
 
    pQueryFilter.WhereClause = "ID = 0 AND PropName = 'NumBest'"
    Set pCursor = pOptimizationTable.Search(pQueryFilter, False)
    Set pRow = pCursor.NextRow

    pRowString = "-99"

    If Not IsNull(pRow) Then
        pRowString = pRow.value(iPropValue)
    End If
    If pRowString = "-99" Then
        NumBest.Text = "1"
    Else
        NumBest.Text = pRowString
    End If

    pQueryFilter.WhereClause = "ID = 0 AND PropName = 'StopDelta'"
    Set pCursor = pOptimizationTable.Search(pQueryFilter, False)
    Set pRow = pCursor.NextRow
    pRowString = "-99"
    If Not IsNull(pRow) Then
        pRowString = pRow.value(iPropValue)
    End If
    If pRowString = "-99" Then
        StopDelta.Text = "1000"
    Else
        StopDelta.Text = pRowString
    End If
    
    pQueryFilter.WhereClause = "ID = 0 AND PropName = 'MaxRunTime'"
    Set pCursor = pOptimizationTable.Search(pQueryFilter, False)
    Set pRow = pCursor.NextRow
    pRowString = pRow.value(iPropValue)
    If pRowString <> "" And pRowString <> "-99" Then
        MaxRunTime.Text = pRowString
    Else
        Dim NumDV As Integer
        NumDV = GetNumofOptimizations
        'If (4 * NumDV) < 80 Then
        '    MaxRunTime.Text = "80"
        'Else
        '    MaxRunTime.Text = CStr(4 * NumDV)
        'End If
        MaxRunTime.Text = CStr(80 * NumDV)
    End If
End Sub

