VERSION 5.00
Begin VB.Form FrmSWMMDefineSimulationOptions 
   Caption         =   "Define Infiltration Simulation Options"
   ClientHeight    =   1710
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3510
   DrawWidth       =   10
   LinkTopic       =   "Form1"
   ScaleHeight     =   1710
   ScaleWidth      =   3510
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Cancel"
      Height          =   255
      Left            =   1920
      TabIndex        =   3
      Top             =   960
      Width           =   855
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   255
      Left            =   1920
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.OptionButton optHorton 
      Caption         =   "Horton"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   960
      Width           =   1455
   End
   Begin VB.OptionButton optGreenAmpt 
      Caption         =   "Green Ampt"
      Height          =   375
      Left            =   360
      TabIndex        =   0
      Top             =   480
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Caption         =   "Infiltration Simulation Option"
      Height          =   1215
      Left            =   240
      TabIndex        =   4
      Top             =   240
      Width           =   3015
   End
End
Attribute VB_Name = "FrmSWMMDefineSimulationOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private sSimulationOpt As String
Public Function getSimulationOpt()
    getSimulationOpt = sSimulationOpt

End Function
Public Sub setSimulationOpt(sSimulate)
    sSimulationOpt = sSimulate

End Sub

Private Sub cmdOK_Click()
On Error GoTo ShowError
    'read the LANDOptions
    Dim pSWMMOptionsTable As iTable
    Set pSWMMOptionsTable = GetInputDataTable("LANDOptions")
    
    Dim pQueryFilter As IQueryFilter
    Set pQueryFilter = New QueryFilter
    pQueryFilter.WhereClause = "PropName = 'Name'"
    
    'Create the table if not found, add it to the Map
    If (pSWMMOptionsTable Is Nothing) Then
        Set pSWMMOptionsTable = CreatePropertiesTableDBF("LANDOptions")
        AddTableToMap pSWMMOptionsTable
    Else
        pSWMMOptionsTable.DeleteSearchedRows Nothing
    End If

    Dim iPropName As Long
    Dim iPropValue As Long
    iPropName = pSWMMOptionsTable.FindField("PropName")
    iPropValue = pSWMMOptionsTable.FindField("PropValue")
    
    Dim pPropertyName As String
    Dim pPropertyValue As String
    Dim pRow As iRow
    Dim i As Integer
    pPropertyName = "INFILTRATION"
    
    If optGreenAmpt.value = True Then
        setSimulationOpt "Green-Ampt"
        pPropertyValue = "Green-Ampt"
        'FrmSWMMSubCatchmentProperties.txtConductivity.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtSuctionHead.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtInitialDeficit.Enabled = True
        
        'FrmSWMMSubCatchmentProperties.txtMaxInfilRate.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtMinInfilRate.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtDecayConst.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtDryingTime.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtMaxVolume.Enabled = False

    Else
        setSimulationOpt "Horton"
        pPropertyValue = "Horton"
        'FrmSWMMSubCatchmentProperties.txtConductivity.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtSuctionHead.Enabled = False
        'FrmSWMMSubCatchmentProperties.txtInitialDeficit.Enabled = False
        
        'FrmSWMMSubCatchmentProperties.txtMaxInfilRate.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtMinInfilRate.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtDecayConst.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtDryingTime.Enabled = True
        'FrmSWMMSubCatchmentProperties.txtMaxVolume.Enabled = True
        
    End If
    
    Set pRow = pSWMMOptionsTable.CreateRow
    pRow.value(iPropName) = pPropertyName
    pRow.value(iPropValue) = pPropertyValue
    pRow.Store
    GoTo CleanUp
    
ShowError:
    MsgBox "Error in SWMM Define Simulation Options: " & Err.description
CleanUp:
    Set pSWMMOptionsTable = Nothing
    Set pRow = Nothing
    Set pQueryFilter = Nothing
    Unload Me

End Sub

Private Sub Command1_Click()
    Unload Me
End Sub

Private Sub Form_Load()
On Error GoTo ShowError


    Dim pSWMMOptionsTable As iTable
    Set pSWMMOptionsTable = GetInputDataTable("LANDOptions")
    If (pSWMMOptionsTable Is Nothing) Then
        setSimulationOpt ""
        optGreenAmpt.value = True
        optHorton.value = False
    
        Exit Sub
    End If
    
    '* find the previously saved InfiltrationMethod
    Dim iPropName As Long
    iPropName = pSWMMOptionsTable.FindField("PropName")
    Dim iPropValue As Long
    iPropValue = pSWMMOptionsTable.FindField("PropValue")
    
    '* define query filter
    Dim pQueryFilter As IQueryFilter
    Set pQueryFilter = New QueryFilter
    pQueryFilter.WhereClause = "PropName = " & "'INFILTRATION'"
    
    '* get the cursor to iterate over the table
    Dim pCursor As ICursor
    Set pCursor = pSWMMOptionsTable.Search(pQueryFilter, True)
    
    '* define a row variable to loop over the table
    Dim pRow As iRow
    Set pRow = pCursor.NextRow
    Dim sSimulationOption As String
    If Not pRow Is Nothing Then
        sSimulationOption = CStr(pRow.value(iPropValue) & "")
        setSimulationOpt sSimulationOption
        If sSimulationOption = "Green-Ampt" Then
            optGreenAmpt.value = True
            optHorton.value = False
        ElseIf sSimulationOption = "Horton" Then
            optGreenAmpt.value = False
            optHorton.value = True
        End If
    Else
        setSimulationOpt ""
        optGreenAmpt.value = True
        optHorton.value = False
    End If
    GoTo CleanUp
ShowError:
    MsgBox "Error in Load Define Simulation Options: " & Err.description
CleanUp:
    Set pSWMMOptionsTable = Nothing
    Set pRow = Nothing
    Set pCursor = Nothing
    Set pQueryFilter = Nothing
End Sub

