VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ToggleBMPIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'******************************************************************************
'   Application: SUSTAIN - Best Management Practice Decision Support System
'   Company:     Tetra Tech, Inc
'   Designer:    Leslie Shoemaker, Ting Dai, Khalid Alvi, Jenny Zhen, John Riverson, Sabu Paul
'   Developer:   Haihong Yang, Sabu Paul, Mira Chokshi
'   History:     Created:
'                Modified: 03/29/2005 - mira chokshi added comments to project
'
'******************************************************************************


Option Explicit
Implements ICommand
Private m_Bitmap As IPictureDisp

Private Sub Class_Initialize()
    Set m_Bitmap = LoadResPicture("TOGGLE", vbResBitmap)
End Sub

Private Sub Class_Terminate()
    Set m_Bitmap = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
    ICommand_Bitmap = m_Bitmap
End Property

Private Property Get ICommand_Caption() As String
    ICommand_Caption = "Toggle BMP Icon/Point View"
End Property

Private Property Get ICommand_Category() As String
    ICommand_Category = "SUSTAIN"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
       'ICommand_Enabled = ModuleMenu.EnableEditBMP
       ICommand_Enabled = True
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
    ICommand_Message = "Toggle BMP Icon/Point View"
End Property

Private Property Get ICommand_Name() As String
    ICommand_Name = "Toggle BMP Icon/Point View"
End Property

Private Sub ICommand_OnClick()
    Call InitializeMapDocument
    Dim pTable As iTable
    Set pTable = GetInputDataTable("BMPDetail")
    If (pTable Is Nothing) Then
        Set pTable = GetInputDataTable("AgBMPDetail")
        If pTable Is Nothing Then
            MsgBox "Please add BMP first.", vbExclamation
            Exit Sub
        End If
    End If
    Dim pFeatureLayer As IFeatureLayer
    Set pFeatureLayer = GetInputFeatureLayer("BMPs")
    
    Dim pFeatureLayerBufferStrip As IFeatureLayer
    Set pFeatureLayerBufferStrip = GetInputFeatureLayer("VFS")
    
    If (pFeatureLayer Is Nothing) And (pFeatureLayerBufferStrip Is Nothing) Then
        MsgBox "Please add BMP first", vbExclamation
        Exit Sub
    End If
    Call ToggleBMPIconPointView
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
    Set gApplication = hook
End Sub

Private Property Get ICommand_Tooltip() As String
    ICommand_Tooltip = "Toggle BMP Icon/Point View"
End Property
