// AQUIFER.h: interface for the CAQUIFER class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AQUIFER_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)
#define AFX_AQUIFER_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Aquifer.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAquifer Object

class CAquifer : public CObject
{
// Construction
public:
	CAquifer();
	CAquifer(int nAquiferID, CString strAquiferName, double lfGWrc, double lfGWsc, double lfGWStorage);
	virtual ~CAquifer();

// Attributes
public:
	int m_nAquiferID;		// Aquifer unique ID (non zero)
	CString m_sAquiferName;	// Aquifer Name
	double m_lfGWrc;		// GW recession coefficient (per hour)
	double m_lfGWsc;		// GW seepage coefficient (per hour)
	double m_lfGWStorage_i;	// GW storage (initial) (ac-ft)
	double m_lfGWStorage_u;	// GW storage (updated) (ac-ft)
	double* m_pConc;		// array of background concentration (mg/l)
};

#endif // !defined(AFX_AQUIFER_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)


