// Ftable.h: interface for the CFtable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_Ftable_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)
#define AFX_Ftable_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Ftable.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFtable Object

class CFtable : public CObject
{
// Construction
public:
	CFtable();
	CFtable(CString strFtableID,int nRecords,double lfLength,double lfSlope,
			double* lfDepth,double* lfArea,double* lfVolume,double* lfWetPerimeter,
			double* lfWeirOutflow,double* lfOrificeOutflow);
	virtual ~CFtable();

// Attributes
public:
	CString m_strFtableID;		// Unique Ftable identifier
	int     m_nRecords;			// Number of records in table
	double	m_lfLength;			// Flow length (ft)
	double	m_lfSlope;			// Slope of flow length (ft/ft)
	double*	m_lfDepth;			// array of depth (ft)
	double*	m_lfArea;			// array of surface area (ft2)
	double*	m_lfVolume;			// array of storage volume (ft3)
	double*	m_lfWetPerimeter;	// array of wetted perimeter (ft)
	double*	m_lfWeirOutflow;	// array of weir outflow rate (cfs)
	double*	m_lfOrificeOutflow;	// array of orifice outflow rate (cfs)

//functions
public:
	double table_interpolate(double x,double x1,double y1,double x2,double y2);
	double Depth_lookup(double x,double* y);
	double Volume_lookup(double x,double* y);
};

#endif // !defined(AFX_Ftable_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)


