// Pump.h: interface for the CPUMP class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PUMP_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)
#define AFX_PUMP_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Pump.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPUMP Object

class CPUMP : public CObject
{
// Construction
public:
	CPUMP();
	CPUMP(CString strPCurveID, int nRecords, double* lfDepth, double* lfFlow);
	virtual ~CPUMP();

// Attributes
public:
	CString m_strPCurveID;	// Unique pump curve identifier
	int     m_nRecords;		// Number of points on the curve
	double*	m_lfDepth;		// array of depth (ft)
	double*	m_lfFlow;		// array of flow (cfs)

//functions
public:
	double table_interpolate(double x, double x1, double y1, double x2, double y2);
	double table_lookup(double x);
};

#endif // !defined(AFX_PUMP_H__407EACB7_B136_487D_816A_85AE5D55E1EF__INCLUDED_)


